import oscP5.*;
import netP5.*;

OscP5 oscP5;

boolean sliderLifted;
int rootCount;
int curInterval = 0;
int maxIntervalDifference = 1;

int curIntervalSettlingTime = 0;
int minIntervalSettlingTime = 2;
int curSettlingInterval = 0;

int curPageNumber = 0;
/*
  pg |  content
  0  |  slider
  1  |  button1,2
  2  |  o (rotation)
  3  |  ^ (proximity)
*/

PFont font;

int swidth = 400; int sheight = 400;
void setup() {
  colorMode(HSB, 100);
  size(swidth, sheight);
  //frameRate(25);
  oscP5 = new OscP5(this, 8000);

  sliderLifted = true;
  rootCount = 0;
  
  font = loadFont("Serif-48.vlw");
  textFont(font);
}


void draw() {
  //background(0);
  text(curInterval,swidth/2-10,sheight/2);
}


void oscEvent(OscMessage theOscMessage) {
  
  print("OSC Message: ");
  //ADDR PATTERN
  String addrPattern = theOscMessage.addrPattern();
  print("     AddrPattern: "+addrPattern);

  //GENERAL TYPE TAG
  print("     TypeTag: "+theOscMessage.typetag());
  if (theOscMessage.checkTypetag("f") == true) {
    float fvalue = theOscMessage.get(0).floatValue();
    print("     Float Value: "+fvalue);
    background(fvalue*27, 80, fvalue*80+20);

    //if addrPattern ends with "/z" then slider lifted. else slider pressed.    
    String[] addrParts = addrPattern.split("/");
    if (addrParts[addrParts.length-1].equals("z")) {
      sliderLifted = true;
    } 
    else {
      sliderLifted = false;
    }
  } 
  else {

    if (sliderLifted) {

      //ACCXYZ – FFF TYPE TAG

      /*
    if (theOscMessage.checkAddrPattern("/accxyz") == true) {
       float fz = theOscMessage.get(2).floatValue();
       fz = (int)(fz*5+0.5)/5.0;
       print("     Z Value: "+fz);//(fz*90+90));
       background(45, 80, ((fz+1)/2.0)*60+40);
       }
       */

      if (theOscMessage.checkAddrPattern("/accxyz") == true) {
        float fz = theOscMessage.get(2).floatValue();
        fz=(fz+1.0)/2.0;
        fz = (int)(fz*10+0.5)/10.0;
        print("     Z Value: "+fz);//(fz*90+90));
        int angleInterval = (int)(fz*10);
        if (abs(angleInterval-curInterval)>maxIntervalDifference) {
          //CHANGE INTERVAL. //IF INTERVAL DIFFERENCE TOO GREAT! //(Note, an extra timer could also be added to this for glitch points)
          curInterval = angleInterval;
          curIntervalSettlingTime = 0;
        } 
        else {
          //if angleInterval is different to curInterval
          if (angleInterval!=curInterval) {

            //if angleInterval is same as curSettlingInterval - add.
            //if different then reset curSettlingInterval and curIntervalSettlingTime.
            if (angleInterval==curSettlingInterval) {
              
              curIntervalSettlingTime++;
              if (curIntervalSettlingTime>minIntervalSettlingTime) {
                //CHANGE INTERVAL. //a small interval. //IF HELD.
                curInterval = angleInterval;
                curIntervalSettlingTime = 0;
              }
              
            } else {
              curIntervalSettlingTime = 0;
              curSettlingInterval = angleInterval;
            }
          }
        }
        if (curInterval>10)curInterval=10; if(curInterval<0)curInterval=0;

        print("     CURRENT INTERVAL: "+curInterval);
        //background(45, 80, fz*60+40);
        background(45, 80, (curInterval*1.0/10.0)*60+40);
      }

      /*
    if (theOscMessage.checkAddrPattern("/accxyz") == true) {
       float fz = theOscMessage.get(2).floatValue();
       if (fz>1) fz=1; if (fz<-1) fz=-1;
       fz = -(acos(fz)/PI*2-1);
       fz = (int)(fz*5+0.5)/5.0;
       print("     Z Value: "+fz);//(fz*90+90));
       background(45, 80, ((fz+1)/2.0)*60+40);
       }
       */
      /*
    if (theOscMessage.checkAddrPattern("/accxyz") == true) {
       float fz = theOscMessage.get(2).floatValue();
       if (fz>1) fz=1; if(fz<-1) fz=-1;
       double value = acos(fz)/PI;
       //fz = (int)(fz*5.5)/5.0;
       value = (int)(value*10.0)/10.0;
       print("     Value: "+value + "     fz: "+fz);//(fz*90+90));
       background(45, 80, (int)(value*60+40));
       }
       */
    }
  }

  println();
}

