
int serialPort = 9600;

int motorWriteValue = 0; 
int motorWriteMaxValue = 254; //value from 0 to 254.
int motorDigitalPin = 11;
int motorChangeRate = 1; //write 0 for constant speed
int motorReadRate = 300;

int micReadRate = 100; //higher the slower
int micReadValue;
int micAnalogPin = 0;

int ledPinR = 3;
int ledPinY = 5;
int ledPinG = 6;

int ledPinW = 9;

int rootFrame = 0;

byte serialRead;
byte timeval, peekval;

void setup()  { 
  Serial.begin(serialPort);
  pinMode(micAnalogPin, OUTPUT);
  pinMode(motorDigitalPin, OUTPUT);
  pinMode(ledPinR, OUTPUT);

}

void loop()  { 

  rootFrame += 1;

  if (rootFrame%micReadRate==0) {
    micReadValue = analogRead(micAnalogPin);
    Serial.println(micReadValue, DEC);
  }

  if (rootFrame%motorReadRate==0) {

    motorWriteValue = (motorWriteValue+motorChangeRate) % motorWriteMaxValue;
    //analogWrite(motorDigitalPin, motorWriteValue);  
    analogWrite(motorDigitalPin, (peekval/255)*(peekval/255)*0.8);  
  }
  
  //----------------
  
  while (Serial.available() > 2){
    serialRead = Serial.read();
    if (serialRead == 'A'){
      timeval = Serial.read();
      peekval = Serial.read();
      //analogWrite(3,aval);
    }
  }
  
  int r = map(timeval,127,0,0,254); if(r>254) r=254; if(r<0) r=0;
  int y = map(abs(timeval-127),127,0,0,254);
  int g = map(timeval,127,254,0,254); if(g>254) g=254; if(g<0) g=0;

  analogWrite(ledPinR, r);
  analogWrite(ledPinY, y);
  analogWrite(ledPinG, g);

  analogWrite(ledPinW, peekval);
}





